/*
 * PM - 2017
 * lab0.c
 */

#include <avr/io.h>
#include <util/delay.h>

int step1 = 0;
int step2 = 0;

#define LOW 0
#define HIGH 1

void digitalWrite(volatile uint8_t* port, int pin, int level) {
	if (level == 1) {
		*port |= (1 << pin);	
	} else {
		*port &= ~(1 << pin);
	}
}

void loop(volatile uint8_t* port, int Pin0, int Pin1, int Pin2, int Pin3, int * step)
{
	 switch(*step) {
	 case 0:
		 digitalWrite(port, Pin0, HIGH);
		 digitalWrite(port, Pin1, LOW);
		 digitalWrite(port, Pin2, LOW);
		 digitalWrite(port, Pin3, HIGH); //HIGH
		 break;
	 case 1:
		 digitalWrite(port, Pin0, HIGH); // HIGH
		 digitalWrite(port, Pin1, HIGH);
		 digitalWrite(port, Pin2, LOW);
		 digitalWrite(port, Pin3, LOW);
		 break;
	 case 2:
		 digitalWrite(port, Pin0, LOW);
		 digitalWrite(port, Pin1, HIGH); //HIGH
		 digitalWrite(port, Pin2, HIGH);
		 digitalWrite(port, Pin3, LOW);
		 break;
	 default:
		 digitalWrite(port, Pin0, LOW);
		 digitalWrite(port, Pin1, LOW);
		 digitalWrite(port, Pin2, HIGH); //HIGH
		 digitalWrite(port, Pin3, HIGH);
		 break;
	 }
	*step = *step + 1;
	
	
	if (*step > 3) {
		*step = 0;
	}
} 

int main(void) {
	
	/*	
		Motor 1:
		Pini out:
		PB0
		PB1
		PB2
		PB3
		
		Motor 2:
		Pinit out:
		PA0
		PA1
		PA2
		PA3
		
	*/
	DDRB |= (1 << PB0);
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB3);
	
	DDRA |= (1 << PA0);
	DDRA |= (1 << PA1);
	DDRA |= (1 << PA2);
	DDRA |= (1 << PA3);
	
	DDRD |= (1 << PD7);
	while(1) {
        
		loop(&PORTB, PB0, PB1, PB2, PB3, &step1);
		loop(&PORTA, PA0, PA1, PA2, PA3, &step2);
		
		PORTD ^= (1 << PD7);
		_delay_ms(5);
	}

	return 0;
}
